﻿Public Class TextBoxWithDelay

#Region "Public Properties"
    Public Property ActivateDelay As Boolean = False
    Public Property DelayTime As Integer = 500
    Public Property MinimumTextLengthBeforeDelayStart As Integer = 3
#End Region

#Region "Public Events"

    Public Event TimerDelayed(SearchText As String)
#End Region

#Region "Private Properties"
    Private Property TimerIsRunning As Boolean = False
    Private Property TimerWasRaised As Integer = 0
#End Region

#Region "Public Methods"
    Public Sub New()
        MyBase.New
        InitializeComponent()

        AddHandler Me.KeyDown, AddressOf myTextChanged
    End Sub
#End Region

#Region "Private Methods"
    Private myTimer As New Threading.Timer(Sub()
                                               TimerWasRaised += 1
                                               If TimerIsRunning = True Then Exit Sub
                                               Dim locTimerWasRaised = TimerWasRaised
                                               TimerIsRunning = True
                                               If TimerWasRaised = locTimerWasRaised Then
                                                   RaiseEvent TimerDelayed(Me.Text)
                                               End If
                                               TimerIsRunning = False
                                               TimerWasRaised = 0
                                           End Sub, Nothing, Threading.Timeout.Infinite, Threading.Timeout.Infinite)

    Private Sub myTextChanged(ByVal sender As Object, ByVal e As EventArgs)
        If Me.ActivateDelay = True Then
            If CheckMinimumLength() = True Then

                myTimer.Change(DelayTime, Threading.Timeout.Infinite)
            End If
        End If
    End Sub
    Private Function CheckMinimumLength() As Boolean
        If Me.Text.Length >= MinimumTextLengthBeforeDelayStart Then
            Return True
        Else
            Return False
        End If
    End Function
#End Region

End Class
